(define (domain logistics)
	(:requirements :typing :numeric-fluents :action-costs)
	(:types 
		location 
		package 
		truck plane - vehicle	;;trucks and planes are vehicles
	)
	(:predicates
		(vehicle-at ?v - vehicle ?at - location)
		(road ?from ?to - location)				;;for truck
		(corridor ?from ?to - location)			;;for plane
	)

	(:functions
		(total-cost)
		(travel-cost ?v - vehicle)
		(distance ?from ?to - location)
		(capacity ?v - vehicle)
		(packages-at ?l - location)
		(packages-in ?v - vehicle)
	)
	
	;;we need separate move actions because of the different types of road/corridor
	
	(:action move-truck
		:parameters (?t - truck ?from ?to - location)
		:precondition (and (vehicle-at ?t ?from) (road ?from ?to))
		:effect (and (not (vehicle-at ?t ?from)) (vehicle-at ?t ?to) (increase (total-cost) (* (distance ?from ?to) (travel-cost ?t))))
	)
	
	(:action move-plane
		:parameters (?a - plane ?from ?to - location)
		:precondition (and (vehicle-at ?a ?from) (corridor ?from ?to))
		:effect (and (not (vehicle-at ?a ?from)) (vehicle-at ?a ?to) (increase (total-cost) (* (distance ?from ?to) (travel-cost ?a))))
	)
	
	;;load/unload can be the same for both vehicles
	
	(:action load
		:parameters (?v - vehicle ?where - location)
		:precondition (and (vehicle-at ?v ?where) (> (packages-at ?where) 0) (< (packages-in ?v) (capacity ?v)))
		:effect (and (increase (packages-in ?v) 1) (decrease (packages-at ?where) 1))
	)
	
	(:action unload
		:parameters (?v - vehicle  ?where - location)
		:precondition (and (vehicle-at ?v ?where) (> (packages-in ?v) 0))
		:effect (and (decrease (packages-in ?v) 1) (increase (packages-at ?where) 1))
	)
)
